VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   1800
      TabIndex        =   0
      Top             =   1320
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' This doesn't work if the Type contains variable
' length strings.
Private Type MyType
    StringValue As String * 20
    IntegerValue As Integer
    IntegerArray(1 To 10) As Integer
End Type

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

' Return True if these structures contain the same data.
Private Function MyTypesTheSame(a As MyType, b As MyType) As Boolean
Dim i As Integer
Dim a_bytes() As Byte
Dim b_bytes() As Byte
Dim different As Boolean

    ' Copy the data into arrays of bytes.
    ReDim a_bytes(1 To Len(a))
    ReDim b_bytes(1 To Len(b))

    CopyMemory a_bytes(1), a, Len(a)
    CopyMemory b_bytes(1), b, Len(b)

    ' Compare the bytes.
    For i = 1 To Len(a)
        If a_bytes(i) <> b_bytes(i) Then
            MyTypesTheSame = False
            Exit Function
        End If
    Next i

    MyTypesTheSame = True
End Function

Private Sub Command1_Click()
Dim a As MyType
Dim b As MyType
Dim i As Integer

    With b
        .IntegerValue = 123
        .StringValue = "Here's a string"
        For i = 1 To 10
            .IntegerArray(i) = i * i
        Next i
    End With

    With a
        .IntegerValue = 123
        .StringValue = "Here's a string"
        For i = 1 To 10
            .IntegerArray(i) = i * i
        Next i
    End With

    If MyTypesTheSame(a, b) Then
        MsgBox "The same", , "Match"
    Else
        MsgBox "Different", , "Match"
    End If

    b.StringValue = "Oops"
    If MyTypesTheSame(a, b) Then
        MsgBox "The same", , "Different String"
    Else
        MsgBox "Different", , "Different String"
    End If

    b.StringValue = "Here's a string"
    If MyTypesTheSame(a, b) Then
        MsgBox "The same", , "Match"
    Else
        MsgBox "Different", , "Match"
    End If

    b.IntegerValue = 321
    If MyTypesTheSame(a, b) Then
        MsgBox "The same", , "Different Integer"
    Else
        MsgBox "Different", , "Different Integer"
    End If

    b.IntegerValue = 123
    b.IntegerArray(1) = 2
    If MyTypesTheSame(a, b) Then
        MsgBox "The same", , "Different Integer Array"
    Else
        MsgBox "Different", , "Different Integer Array"
    End If
End Sub
